<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/postcard-1.0.1/src/lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../postcard/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../postcard/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../postcard/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
</pre><pre class="rust"><code><span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">not</span>(<span class="ident">any</span>(<span class="ident">test</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;use-std&quot;</span>)), <span class="ident">no_std</span>)]</span>
<span class="attribute">#![<span class="ident">warn</span>(<span class="ident">missing_docs</span>)]</span>
<span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">not</span>(<span class="ident">doctest</span>), <span class="ident">doc</span> <span class="op">=</span> <span class="macro">include_str!</span>(<span class="string">&quot;../README.md&quot;</span>))]</span>

<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">accumulator</span>;
<span class="kw">mod</span> <span class="ident">de</span>;
<span class="kw">mod</span> <span class="ident">error</span>;
<span class="kw">mod</span> <span class="ident">ser</span>;
<span class="kw">mod</span> <span class="ident">varint</span>;

<span class="comment">// Still experimental! Don&#39;t make pub pub.</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">mod</span> <span class="ident">max_size</span>;
<span class="kw">mod</span> <span class="ident">schema</span>;

<span class="doccomment">/// # Experimental Postcard Features</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Items inside this module require various feature flags, and are not</span>
<span class="doccomment">/// subject to SemVer stability. Items may be removed or deprecated at</span>
<span class="doccomment">/// any point.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ## Derive</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The `experimental-derive` feature enables two experimental features:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// * Max size calculation</span>
<span class="doccomment">/// * Message schema generation</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ### Max Size Calculation</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This features enables calculation of the Max serialized size of a message as</span>
<span class="doccomment">/// an associated `usize` constant called `POSTCARD_MAX_SIZE`. It also provides a</span>
<span class="doccomment">/// `#[derive(MaxSize)]` macro that can be used for calculating user types.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This is useful for determining the maximum buffer size needed when recieving</span>
<span class="doccomment">/// or sending a message that has been serialized.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// NOTE: This only covers the size of &quot;plain&quot; flavored messages, e.g. not with COBS</span>
<span class="doccomment">/// or any other Flavors applied. The overhead for these flavors must be calculated</span>
<span class="doccomment">/// separately.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Please report any missing types, or any incorrectly calculated values.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ### Message Schema Generation</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This feature enables the generation of a schema of a given message at compile</span>
<span class="doccomment">/// time. At the moment, this is only exposed as a [`NamedType`](crate::experimental::schema::NamedType)</span>
<span class="doccomment">/// which is a recursive data structure describing the schema. In the future, it is planned</span>
<span class="doccomment">/// to provide formatting functions that emit this as a human or machine readable schema.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// NOTE: This only covers the schema of &quot;plain&quot; flavored messages, e.g. not with COBS</span>
<span class="doccomment">/// or any other Flavors applied. The format of these flavors must be calculated</span>
<span class="doccomment">/// separately.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Please report any missing types, or any incorrectly calculated schemas.</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">experimental</span> {
    <span class="doccomment">/// Compile time max-serialization size calculation</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;experimental-derive&quot;</span>)]</span>
    <span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">max_size</span> {
        <span class="comment">// NOTE: This is the trait...</span>
        <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::max_size::MaxSize</span>;
        <span class="comment">// NOTE: ...and this is the derive macro</span>
        <span class="kw">pub</span> <span class="kw">use</span> <span class="ident">postcard_derive::MaxSize</span>;
    }

    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;experimental-derive&quot;</span>)]</span>

    <span class="doccomment">/// Compile time Schema generation</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;experimental-derive&quot;</span>)]</span>
    <span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">schema</span> {
        <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::schema</span>::<span class="kw-2">*</span>;
        <span class="kw">pub</span> <span class="kw">use</span> <span class="ident">postcard_derive::Schema</span>;
    }
}

<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">de::deserializer::Deserializer</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">de::flavors</span> <span class="kw">as</span> <span class="ident">de_flavors</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">de</span>::{<span class="ident">from_bytes</span>, <span class="ident">from_bytes_cobs</span>, <span class="ident">take_from_bytes</span>, <span class="ident">take_from_bytes_cobs</span>};
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">error</span>::{<span class="ident">Error</span>, <span class="prelude-ty">Result</span>};
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">ser::flavors</span> <span class="kw">as</span> <span class="ident">ser_flavors</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">ser</span>::{<span class="ident">serialize_with_flavor</span>, <span class="ident">serializer::Serializer</span>, <span class="ident">to_slice</span>, <span class="ident">to_slice_cobs</span>};

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;heapless&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">ser</span>::{<span class="ident">to_vec</span>, <span class="ident">to_vec_cobs</span>};

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;use-std&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">ser</span>::{<span class="ident">to_stdvec</span>, <span class="ident">to_stdvec_cobs</span>};

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">ser</span>::{<span class="ident">to_allocvec</span>, <span class="ident">to_allocvec_cobs</span>};

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">test</span> {
    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">varint_boundary_canon</span>() {
        <span class="kw">let</span> <span class="ident">x</span> <span class="op">=</span> <span class="ident">u32::MAX</span>;
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">buf</span> <span class="op">=</span> [<span class="number">0u8</span>; <span class="number">5</span>];
        <span class="kw">let</span> <span class="ident">used</span> <span class="op">=</span> <span class="ident"><span class="kw">crate</span>::to_slice</span>(<span class="kw-2">&amp;</span><span class="ident">x</span>, <span class="kw-2">&amp;mut</span> <span class="ident">buf</span>).<span class="ident">unwrap</span>();
        <span class="kw">let</span> <span class="ident">deser</span>: <span class="ident">u32</span> <span class="op">=</span> <span class="ident"><span class="kw">crate</span>::from_bytes</span>(<span class="ident">used</span>).<span class="ident">unwrap</span>();
        <span class="macro">assert_eq!</span>(<span class="ident">deser</span>, <span class="ident">u32::MAX</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">used</span>, <span class="kw-2">&amp;mut</span> [<span class="number">0xFF</span>, <span class="number">0xFF</span>, <span class="number">0xFF</span>, <span class="number">0xFF</span>, <span class="number">0x0F</span>]);
        <span class="kw">let</span> <span class="ident">deser</span>: <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">u32</span>, <span class="ident"><span class="kw">crate</span>::Error</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident"><span class="kw">crate</span>::from_bytes</span>(<span class="kw-2">&amp;</span>[<span class="number">0xFF</span>, <span class="number">0xFF</span>, <span class="number">0xFF</span>, <span class="number">0xFF</span>, <span class="number">0x1F</span>]);
        <span class="macro">assert_eq!</span>(<span class="ident">deser</span>, <span class="prelude-val">Err</span>(<span class="ident"><span class="kw">crate</span>::Error::DeserializeBadVarint</span>));
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">signed_int128</span>() {
        <span class="kw">let</span> <span class="ident">x</span> <span class="op">=</span> <span class="op">-</span><span class="number">19490127978232325886905073712831_i128</span>;
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">buf</span> <span class="op">=</span> [<span class="number">0u8</span>; <span class="number">32</span>];
        <span class="kw">let</span> <span class="ident">used</span> <span class="op">=</span> <span class="ident"><span class="kw">crate</span>::to_slice</span>(<span class="kw-2">&amp;</span><span class="ident">x</span>, <span class="kw-2">&amp;mut</span> <span class="ident">buf</span>).<span class="ident">unwrap</span>();
        <span class="kw">let</span> <span class="ident">deser</span>: <span class="ident">i128</span> <span class="op">=</span> <span class="ident"><span class="kw">crate</span>::from_bytes</span>(<span class="ident">used</span>).<span class="ident">unwrap</span>();
        <span class="macro">assert_eq!</span>(<span class="ident">deser</span>, <span class="ident">x</span>);
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="postcard" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>